package algorithms;

import Jama.Matrix;
import java.io.Serializable;
import java.util.List;
import objects.DistanceMatrix;
import objects.Template;

public abstract class Classifier implements Serializable {

    private DistanceTemplates distanceTemplates;
    private DistanceMatrix distanceMatrix;
    private Matrix transformationMatrix;

    public Classifier() {
    }

    public DistanceTemplates getDistanceTemplates() {
        return distanceTemplates;
    }

    public void setDistanceTemplates(DistanceTemplates distanceTemplates) {
        this.distanceTemplates = distanceTemplates;
    }

    public DistanceMatrix getDistanceMatrix() {
        return distanceMatrix;
    }

    public void setDistanceMatrix(DistanceMatrix distanceMatrix) {
        this.distanceMatrix = distanceMatrix;
    }

    public Matrix getTransformationMatrix() {
        return transformationMatrix;
    }

    public void setTransformationMatrix(Matrix transformationMatrix) {
        this.transformationMatrix = transformationMatrix;
    }

    public abstract void importTemplatesGallery(List<Template> templatesGallery);

    public abstract String classify(Template templateProbe);

    public double getDistance(Template template1, Template template2) {
        return distanceMatrix == null ? distanceTemplates.getDistance(template1, template2) : distanceMatrix.getDistance(template1, template2);
    }
}
