package algorithms;

import java.util.List;
import objects.Template;

public class Classifier1NN extends Classifier {
    
    private List<Template> templatesGallery;

    @Override
    public void importTemplatesGallery(List<Template> templatesGallery) {
        this.templatesGallery = templatesGallery;
    }

    @Override
    public String classify(Template templateProbe) {
        Template closestTemplate = templatesGallery.get(0);
        double minDistance = Double.MAX_VALUE;
        for (Template template : templatesGallery) {
            double distance = getDistance(template, templateProbe);
            if (minDistance > distance) {
                minDistance = distance;
                closestTemplate = template;
            }
        }
        return closestTemplate.getSubject();
    }
}
