package methods;

import algorithms.Classifier1NN;
import algorithms.DistanceTemplatesL1;
import algorithms.DistancePosesL1;
import algorithms.MotionLoader;
import java.util.ArrayList;
import java.util.List;
import objects.Feature;
import objects.Motion;
import objects.MotionJointCoordinates;
import objects.Parameter;

public class MethodAli extends Method {

    public MethodAli(MotionLoader motionLoader) {
        super(motionLoader);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        Classifier1NN classifier = new Classifier1NN();
        DistanceTemplatesL1 distanceTemplates = new DistanceTemplatesL1();
        distanceTemplates.setDistancePoses(new DistancePosesL1());
        classifier.setDistanceTemplates(distanceTemplates);
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) { // mean of the hip-knee-ankle triangle areas
        MotionJointCoordinates motionMJC = (MotionJointCoordinates) motion;
        List<Feature> features = new ArrayList();
        features.add(new Feature(new Parameter("left", motionMJC.extractTriangleAreaFeature("lhipjoint", "lfemur", "ltibia").getMean())));
        features.add(new Feature(new Parameter("right", motionMJC.extractTriangleAreaFeature("rhipjoint", "rfemur", "rtibia").getMean())));
        return features;
    }
}
