package methods;

import algorithms.Classifier1NN;
import algorithms.DistanceTemplatesDTW;
import algorithms.DistancePosesL1;
import algorithms.MotionLoader;
import java.util.ArrayList;
import java.util.List;
import objects.Axis;
import objects.Feature;
import objects.Motion;
import objects.MotionJointCoordinates;

public class MethodJiang extends Method {

    public MethodJiang(MotionLoader motionLoader) {
        super(motionLoader);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        Classifier1NN classifier = new Classifier1NN();
        DistanceTemplatesDTW distanceTemplates = new DistanceTemplatesDTW();
        distanceTemplates.setDistancePoses(new DistancePosesL1());
        classifier.setDistanceTemplates(distanceTemplates);
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) {
        MotionJointCoordinates motionMJC = (MotionJointCoordinates) motion;
        List<Feature> features = new ArrayList();
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rhipjoint", "rfemur"));
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rfemur", "rtibia"));
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rclavicle", "rhumerus"));
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rhumerus", "rwrist"));
        return features;
    }
}
