package methods;

import algorithms.Classifier1NN;
import algorithms.DistanceTemplatesDTW;
import algorithms.DistancePosesL1;
import algorithms.MotionLoader;
import java.util.ArrayList;
import java.util.List;
import objects.Feature;
import objects.Motion;
import objects.MotionJointCoordinates;

public class MethodSedmidubsky extends Method {

    public MethodSedmidubsky(MotionLoader motionLoader) {
        super(motionLoader);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        Classifier1NN classifier = new Classifier1NN();
        DistanceTemplatesDTW distanceTemplates = new DistanceTemplatesDTW();
        distanceTemplates.setDistancePoses(new DistancePosesL1());
        classifier.setDistanceTemplates(distanceTemplates);
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) { // DTDS (left clavicle, left hand) and (right clavicle, right hand)
        MotionJointCoordinates motionMJC = (MotionJointCoordinates) motion;
        List<Feature> features = new ArrayList();
        features.add(motionMJC.extractInterJointDistanceFeature("lclavicle", "lhand"));
        features.add(motionMJC.extractInterJointDistanceFeature("rclavicle", "rhand"));
        return features;
    }
}
