package methods;

import algorithms.Classifier;
import algorithms.ClassifierRandom;
import algorithms.DistanceTemplatesL1;
import algorithms.MotionLoader;
import java.util.ArrayList;
import java.util.List;
import objects.Feature;
import objects.Motion;

public class Method_Random extends Method {

    private final Classifier classifier = new ClassifierRandom();
    
    public Method_Random(MotionLoader motionLoader) {
        super(motionLoader);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        classifier.setDistanceTemplates(new DistanceTemplatesL1());
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) {
        return new ArrayList();
    }
}
