package methods;

import algorithms.Classifier;
import algorithms.Classifier1NN;
import algorithms.DistanceTemplatesDTW;
import algorithms.DistancePosesL2;
import algorithms.MotionLoader;
import java.util.List;
import objects.Feature;
import objects.Motion;

public class Method_Raw extends Method {

    private final Classifier classifier = new Classifier1NN();

    public Method_Raw(MotionLoader motionLoader) {
        super(motionLoader);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        DistanceTemplatesDTW distanceTemplates = new DistanceTemplatesDTW();
        distanceTemplates.setDistancePoses(new DistancePosesL2());
        classifier.setDistanceTemplates(distanceTemplates);
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) {
        return motion.extractRawFeatures();
    }
}
